import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

/**
 * @author Tomasz Lubinski
 * (c)2006 algorytm.org
 *
 *  Standard 2 of 5 Bar Code
 */
public class Standard2of5 implements ActionListener {

	private BarCode barCode = new BarCode(); 
	
    JFrame mainFrame;
    JPanel mainPanel;
    JPanel inputPanel;
    
    JTextField inputValue;
    JButton generateButton;
    JBarCode outputBars;
    
	public Standard2of5() {
		mainFrame = new JFrame("Generate Standard 2 of 5 Bar Code");
		mainFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		//create and set all components
		inputPanel = new JPanel();
		inputValue = new JTextField("1234567");
    	generateButton = new JButton("Generate");
    	inputPanel.add(inputValue);
    	inputPanel.add(generateButton);
    	
    	outputBars = new JBarCode();
    	
        //Listen to events from the generate button.
    	inputValue.addActionListener(this);
    	generateButton.addActionListener(this);
    	
        //Create the main panel
		mainPanel = new JPanel(new GridLayout(2, 1));
    	mainPanel.add(inputPanel);
    	mainPanel.add(outputBars);
    	
        mainFrame.getContentPane().add(mainPanel, BorderLayout.CENTER);
        mainFrame.setSize(450, 300);
		mainFrame.setVisible(true);
	}
	
   
    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event-dispatching thread.
     */
	@SuppressWarnings("unused")
    private static void createAndShowGUI() {
        //Make sure we have nice window decorations.
        JFrame.setDefaultLookAndFeelDecorated(true);

         Standard2of5 standard2of5 = new Standard2of5();
    }
    
	public static void main(String[] args) {
        //Schedule a job for the event-dispatching thread:
        //creating and showing this application's GUI.
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                createAndShowGUI();
            }
        });		
	}

	public void actionPerformed(ActionEvent arg0) {
		String code = inputValue.getText();
			
		if (barCode.check(code) == true) {
			outputBars.clear();
			outputBars.setText(code);
			
			//print start character
			outputBars.print(barCode.getStartBars());
			
			//print characters
			for (int i=0; i<code.length(); i++) {
				outputBars.print(barCode.getBars(code.charAt(i)));
			}
			
	        //print check digit
			outputBars.print(barCode.getCheckDigitBars(code));
	        
			//print stio character
			outputBars.print(barCode.getStopBars());
			
			//refresh component
			outputBars.repaint();
		} 
		else {
			JOptionPane.showMessageDialog(mainFrame, "Incorrect input characters");
		}
	}
}
